#include <gtk/gtk.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <sys/mman.h>
#include <linux/videodev.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include "input_video.h"
#include "bttv.h"
#include "gui.h"

gint capture_num=0;
extern guchar b_buf[V4L_WIDTH*V4L_HEIGHT*3];

//画面をクリックした時、その画像を保存する
gint input_video(void){
// video ... file discripta
  FILE *fp, *fp2;
  char filename[40];
  static int read_num=0;

  int end_play_number = PLAY_SECOND*(1000/READ_INTERVAL);
  int mult_value = READ_INTERVAL / SAVE_INTERVAL;

  printf("end = %d ",end_play_number);

  if(capture_num < end_play_number ){
    printf("cap = %d , read_num = %d , ",capture_num,read_num);
 
    // ppm output
    sprintf( filename, "log_video/image%04d.ppm", read_num);
    if( (fp2 = fopen( filename, "wb+") ) < 0){
      printf("file open error.\n");
    }
    sprintf( filename, "../save_video/video/image%04d.ppm", read_num);
    if( (fp = fopen( filename, "rb+") ) < 0){
      printf("file open error.\n");
    }
    
    //ヘッダーのオフセット分を考慮
    while( fgetc(fp) != '\n');
  
    //読み込み
    fread(b_buf,sizeof(guchar) , V4L_WIDTH * V4L_HEIGHT * 3, fp);
    
    //使用したファイルを記録
    fprintf(fp2,"P6 %d %d 255\n",V4L_WIDTH , V4L_HEIGHT); 
    fwrite(b_buf, sizeof(guchar), V4L_WIDTH * V4L_HEIGHT * 6, fp2);
    printf(" read %s \n",filename);
    
    fclose(fp); 
    fclose(fp2);
 
    capture_num += 1;
    read_num = capture_num * mult_value;
  }else{
    printf("over %d files\n",end_play_number);
  }
  
  return 0;
}
